unit SepiaMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs, System.Types, System.UITypes,
  GDIPAPI, GDIPOBJ, Math;

type
  TForm1 = class(TForm)
    FileOpen: TButton;
    Image1: TImage;
    Image2: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    SepiaColorBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    FileSaveBtn: TButton;
    GDiMatGrayBtn: TButton;
    GammaBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SepiaColorBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure GDiMatGrayBtnClick(Sender: TObject);
    procedure GammaBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure TemplateMake;      // Templatef[^[쐬
    procedure SepiaTemplate;     // SepiaTemplatef[^[쐬
    procedure GammaTemplate;     // SepiaGammaTemplatef[^[쐬
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

type
  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray  = ^TPrgbarry;                    // |C^[
                                              // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B
implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW   = 384;                            // \gTCY

  RK    = 0.298912;                           // O[XP[PxW@
  GK    = 0.586611;                           // O[XP[PxW@
  BK    = 0.114478;                           // O[XP[PxW@
  BISU  = 1024;                               // {
  RSISF = 10;                                 // rbgVtg

  SepiaR = 1.000;                             // ZsAW
  SepiaG = 0.835;                             // ZsAW
  SepiaB = 0.475;                             // ZsAW
{
  SepiaR = 0.941;                             // ZsAW
  SepiaG = 0.784;                             // ZsAW
  SepiaB = 0.447;                             // ZsAW
}

  RGamma = 1.55;                              // ԃK}l
  GGamma = 1.15;                              // ΃K}l
  BGamma = 0.55;                              // K}l


// Sepia}gbNX
  ColorMatrix_SepiaScale : TColorMatrix = (
    ( 0.393,  0.349,  0.272,  0.0,  0.0),
    ( 0.769,  0.686,  0.534,  0.0,  0.0),
    ( 0.189,  0.168,  0.131,  0.0,  0.0),
    ( 0.0,    0.0,    0.0,    1.0,  0.0),
    ( 0.0,    0.0,    0.0,    0.0,  1.0));

var
  InBitmap        : TBitmap;                  // rbg}bv
  OutBitmap24     : TBitmap;
  GHeight, GWidth : integer;                  // \[X摜TCY
  Vrect           : Trect;                    // \g
  IHeight, IWidth : Integer;                  // \TCY
  RTemp           : array[0..255] of Cardinal;  // ev[gpz@
  GTemp           : array[0..255] of Cardinal;  // ev[gpz  
  BTemp           : array[0..255] of Cardinal;  // ev[gpz  

  RSTemp          : array[0..255] of Byte;      // ZsAev[gpz@
  GSTemp          : array[0..255] of Byte;      // ZsAev[gpz  
  BSTemp          : array[0..255] of Byte;      // ZsAev[gpz  

  RGTemp          : array[0..255] of Byte;      // ZsAK}ev[gpz@
  GGTemp          : array[0..255] of Byte;      // ZsAK}ev[gpz  
  BGTemp          : array[0..255] of Byte;      // ZsAK}ev[gpz  

procedure TForm1.GammaTemplate;     // SepiaGammaTemplatef[^[쐬
var
  II : Integer;
begin
  for II := 0 to 255 do begin
    RGTemp[II] := Round(255 * Power(II / 255, 1 / RGamma)); // ZsAev[g
    GGTemp[II] := Round(255 * Power(II / 255, 1 / GGamma)); // ZsAev[g
    BGTemp[II] := Round(255 * Power(II / 255, 1 / BGamma)); // ZsAev[g
  end;
end;

procedure TForm1.SepiaTemplate;     // SepiaTemplatef[^[쐬
var
  II : Integer;
begin
  for II := 0 to 255 do begin
    RSTemp[II] := Round(II * SepiaR);           // ZsAev[g
    GSTemp[II] := Round(II * SepiaG);           // ZsAev[g
    BSTemp[II] := Round(II * SepiaB);           // ZsAev[g
  end;
end;

// NTSC W1024{ăev[gf[^[쐬
procedure TForm1.TemplateMake;      // Templatef[^[쐬
var
  II : Integer;
begin
  for II := 0 to 255 do begin
    RTemp[II] := round(RK * BISU * II);                       // ԃev[g
    GTemp[II] := round(GK * BISU * II);                       // ΃ev[g
    BTemp[II] := round(BK * BISU * II);                       // ev[g
  end;
end;

// t@C̃I[v@WIC@t@C̎ނ̂Ŏgp
procedure TForm1.FileOpenClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  SepiaColorBtn.Enabled  := False;
  GDiMatGrayBtn.Enabled  := False;
  GammaBtn.Enabled      := False;
  FileSaveBtn.Enabled   := False;
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  Image2.Canvas.Brush.Style := bsSolid;
  Image2.Canvas.Brush.Color := clBtnface;
  Image2.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        IWidth  := ImageHW;                                   // o͐C[W1̕
        IHeight := ImageHW;                                   // o͐C[W1̍
        if GHeight <= GWidth then                             // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth)
        else
          IWidth := Round(IHeight * GWidth / GHeight);
        Image1.Width := IWidth;
        Image1.Height:= IHeight;
        Image1.Picture.Bitmap.SetSize(IWidth, IHeight);       // \prbg}bvTCY̐ݒ
        Image2.Width := IWidth;
        Image2.Height:= IHeight;
        Image2.Picture.Bitmap.SetSize(IWidth, IHeight);       // \prbg}bvTCY̐ݒ
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
        Image1.Canvas.StretchDraw(VRect, WIC);                // o͘gɕϔ{o
        InBitmap.Width    := GWidth;
        InBitmap.Height   := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
        OutBitmap24.Width := GWidth;
        OutBitmap24.Height:= GHeight;
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  SepiaColorBtn.Enabled   := True;
  GDiMatGrayBtn.Enabled   := True;
  GammaBtn.Enabled        := True;
end;

// NTSCWŋPxϊXɃZsAFɕϊ܂
procedure TForm1.SepiaColorBtnClick(Sender: TObject);        // ZsAFϊ
var
  II, JJ        : Integer;
  InpPrgbarray  : Prgbarray;
  OutParray     : Prgbarray;
  OutInt        : DWORD;
  OutByte       : BYTE;
begin
  for II := 0 to GHeight - 1 do begin
    InpPrgbarray  := InBitmap.ScanLine[II];                   // C|C^ݒ
    OutParray     := OutBitmap24.ScanLine[II];
    for JJ := 0 to GWidth - 1 do begin                        // OFZ
      OutInt :=   RTemp[InpPrgbarray[JJ].rgbtRed]             // ԃev[g
                + GTemp[InpPrgbarray[JJ].rgbtGreen]           // ΃ev[g
                + BTemp[InpPrgbarray[JJ].rgbtBlue];           // ev[g
      OutByte := OutInt shr RSISF;                            // 10rbgEVtg OutInt div 1024
      OutParray[JJ].rgbtBlue  := BSTemp[OutByte];             // ZsAev[gKp
      OutParray[JJ].rgbtGreen := GSTemp[OutByte];             // ZsAev[gΓKp
      OutParray[JJ].rgbtRed   := RSTemp[OutByte];             // ZsAev[gԓKp
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap24);              // o͘gɕϔ{o
  FileSaveBtn.Enabled   := True;
end;

// }gbNXɂZsAϊ
procedure TForm1.GDiMatGrayBtnClick(Sender: TObject);
var
  Gpgraph : TGPGraphics;
  GPImage  : TGPImage;
  GPImageAttr : TGPImageAttributes;
  Astream     : TMemoryStream;
begin
  // GPImage := TGPImage.Create(InFilename);   // TGPImageɃt@C֘At
  // t@CǂݍޑɃ[֏o͂[ǂݍ݂܂
  // [Xg[쐬 inbitmap o
  Astream := TMemoryStream.Create;
  InBitmap.SaveToStream(Astream);

  // [Xg[CTGPBitmap̃IuWFNgɓǂݍݎw
  GPImage := TGPBitmap.Create(TStreamAdapter.Create(AStream, soReference));
//  GPImage := TGPImage.Create(InFilename);                 // TGPImageɃt@C֘At

  // GD+TBitmap̕`nhݒ
  Gpgraph := TGPGraphics.Create(OutBitmap24.Canvas.Handle);

  // TGPImageAttributes̃IuWFNg𐶐
  GPImageAttr := TGPImageAttributes.Create;
  GPImageAttr.SetGamma(1.0);                              // K}lݒ

  // gp}gbNXAgr[gɐݒ
  GPImageAttr.SetColorMatrix(ColorMatrix_SepiaScale);

  // TCanvasStretchDrawɑ
  // GpgraphHandleOutBitmap24.CanvasɎw肳Ă̂OutBitmap24.Canvasɕ`悳܂
  Gpgraph.DrawImage(                                      // Gpgraph (OutBitmap24) ɕ`
              GPImage,                                    // 摜
              MakeRect(0, 0, GWidth, GHeight),            // o͈ʒu TCY@
              0, 0, GPImage.GetWidth, GPImage.GetHeight,  // ͈ʒu TCY
              UnitPixel,                                  // sNZ
              GPImageAttr);                               // Agr[g

  Image2.Canvas.StretchDraw(Vrect, OutBitmap24);          // Image1 Dbitmapϔ{\

  //CreateIuWFNg͉܂B
  GPImageAttr.Free;
  GPImage.Free;
  Gpgraph.Free;
  Astream.Free;
  FileSaveBtn.Enabled   := True;
end;

// K}WɂZsAϊ
procedure TForm1.GammaBtnClick(Sender: TObject);
var
  II, JJ        : Integer;
  InpPrgbarray  : Prgbarray;
  OutParray     : Prgbarray;
  OutInt        : DWORD;
  OutByte       : BYTE;
begin
  for II := 0 to GHeight - 1 do begin
    InpPrgbarray  := InBitmap.ScanLine[II];                   // C|C^ݒ
    OutParray     := OutBitmap24.ScanLine[II];
    for JJ := 0 to GWidth - 1 do begin                        // OFZ
      OutInt :=   RTemp[InpPrgbarray[JJ].rgbtRed]             // ԃev[g
                + GTemp[InpPrgbarray[JJ].rgbtGreen]           // ΃ev[g
                + BTemp[InpPrgbarray[JJ].rgbtBlue];           // ev[g
      OutByte := OutInt shr RSISF;                            // 10rbgEVtg OutInt div 1024
      OutParray[JJ].rgbtBlue  := BGTemp[OutByte];             // ZsAK}ev[gKp
      OutParray[JJ].rgbtGreen := GGTemp[OutByte];             // ZsAK}ev[gΓKp
      OutParray[JJ].rgbtRed   := RGTemp[OutByte];             // ZsAK}ev[gԓKp
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap24);              // o͘gɕϔ{o
  FileSaveBtn.Enabled   := True;
end;

// t@C̃I[v
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutBitmap24);                                               // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  SepiaColorBtn.Enabled := False;
  FileSaveBtn.Enabled   := False;
  GDiMatGrayBtn.Enabled := False;
  GammaBtn.Enabled      := False;
  Image1.Width  := ImageHW;
  Image1.Height := ImageHW;
  Image2.Width  := ImageHW;
  Image2.Height := ImageHW;
  InBitmap      := TBitmap.Create;        // ͉摜p
  OutBitmap24   := TBitmap.Create;        // 24rbgo͗p
  InBitmap.PixelFormat    := pf24bit;     // 24rbgJ[ɐݒ
  OutBitmap24.PixelFormat := pf24bit;     // 24rbgJ[ɐݒ
  TemplateMake;                           // Templatef[^[쐬
  SepiaTemplate;                          // SepiaTemplatef[^[쐬
  GammaTemplate;                          // SepiaGammaTemplatef[^[쐬
end;

// rbg}bv̉@
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap24.Free;
end;


end.
